%%---------------------------------------------
%-----------Barthlemy & Marx (2018)-----------
%----------------------------------------------
% File required for determinacy
% Compute the norm u_q
%%---------------------------------------------

function [dl,rho_fin,rho]= sp2_fra(alpha_1,alpha_2,p_11,p_22,sigma,beta,kappa,option)
A_1=[1 sigma;0 beta];
A_2=[1 sigma;0 beta];
B_1=[1 sigma*alpha_1;-kappa 1];
B_2=[1 sigma*alpha_2;-kappa 1];
At_1=B_1^(-1)*A_1;
At_2=B_2^(-1)*A_2;
At(1:2,1:2)=At_1;At(3:4,3:4)=At_2;
P=[p_11*At_1 (1-p_11)*At_1; (1-p_22)*At_2 p_22*At_2];
Proba=[[p_11 (1-p_11)];[(1-p_22) p_22]];
dl=max(abs(eig(P)));
if nargin==8 & option=='dl'
    rho=Inf;
else

for q=1:16
q;
%q=3;
% %normsig=zeros(1,2^p);
Mind=(double(uint8(dec2bin(0:2^q-1,q))-uint8('0'))+ones(2^q,q))';
%Mind=logical(uint8(dec2bin(0:2^q-1,q))-uint8('0'));
fat1 = At(2*1-1:2*1,2*1-1:2*1);
fat2 = At(2*2-1:2*2,2*2-1:2*2);
normsig=zeros(2^q,1);
for ind=1:2^q
    if rem(ind,2) == 0
        sig = sig_prec;
    else
        %v=dec2bin(ind-1,q);
        sig=eye(2,2);
    %     for k=1:q
    %         Mind(k,ind)=str2num(v(k))+1;
    %     end
        for k=1:q-1
            %sig=sig*Proba(Mind(k,ind),Mind(k+1,ind));
            %At(2*Mind(k,ind)-1:2*Mind(k,ind),2*Mind(k,ind)-1:2*Mind(k,ind))
            if Mind(k,ind) == 1
                %sig=sig*Proba(Mind(k,ind),Mind(k+1,ind))*fat1;
                sig=sig*fat1;
            else
                %sig=sig*Proba(Mind(k,ind),Mind(k+1,ind))*fat2;
                sig=sig*fat2;
            end
            %sig=sig*P(2*Mind(k,ind)-1:2*Mind(k,ind),2*Mind(k+1,ind)-1:2*Mind(k+1,ind));
            %P(2*mod(floor(ind/2^k),2)+1:2*mod(floor(ind/2^k),2)+2,2*mod(floor(ind/2^(k+1)),2)+1:2*mod(floor(ind/2^(k+1)),2)+2)
        end
    end
    sig_prec = sig;
    if rem(ind,2) == 1
        sig = sig * fat1;
    else
        sig = sig * fat2;
    end
    %At(2*Mind(q,ind)-1:2*Mind(q,ind),2*Mind(q,ind)-1:2*Mind(q,ind))
    %sig=sig*At(2*Mind(q,ind)-1:2*Mind(q,ind),2*Mind(q,ind)-1:2*Mind(q,ind));
    %sig = sig * fm;
    fsig = norm(sig,1);
    for k=1:q-1
        fsig = fsig*Proba(Mind(k,ind),Mind(k+1,ind));
    end
    normsig(ind)=fsig;
  %normsig(ind)=norm(sig,1);
end
s=zeros(2,2);
for i=1:2 for j=1:2 for ind=1:2^q if Mind(1,ind)==i if Mind(end,ind)==j s(i,j)=s(i,j)+normsig(ind);end,end,end,end
  
  
end
 rho(q)=(max(eig(s)))^(1/q);
 
end
rho_fin=rho(end); 
end
%for i=1:40 for j=1:40 [dl4(i,j),bm4(i,j)]=deter_revu(0.8+0.025*i,0.8+0.025*j);end, end
%figure;contour([0.825:0.025:1.8],[0.825:0.025:1.8],dl4,1,'r');hold on;contour([0.825:0.025:1.8],[0.825:0.025:1.8],bm4,1,'k');
% for i=1:40 for j=1:40 if dl(i,j)<1 dummy_dl(i,j)=1; else dummy_dl(i,j)=0;end, if spm(i,j)<1 dummy_sp(i,j)=1; else dummy_sp(i,j)=0;end,end,end 
% figure;contour([0.75:0.05:2.7],[0.75:0.05:2.7],dummy_dl,1,'r');hold on;contour([0.75:0.05:2.7],[0.75:0.05:2.7],dummy_sp,1,'k');