%%---------------------------------------------
%-----------Barthlemy & Marx (2018)-----------
%----------------------------------------------
% Required for graph_studycase2
% Compute in which case of Proposition 3 we are.
%%---------------------------------------------

function [out] = study_case2(alpha1,alpha2,mu1,mu2,p)
%alpha1=0.8;alpha2=0.5;mu2=0;p=0.9;
r=roots([alpha2*(1-p) (p*alpha2*alpha2-alpha1*alpha2+mu2*(1-p)) 2*alpha2*p*mu2-mu2*alpha1 p*mu2*mu2-mu1]); 
r1=[mu2/r(1)+alpha2;mu2/r(2)+alpha2;mu2/r(3)+alpha2];
r2=r;
nu=p./abs(r1)+(1-p)./abs(r2);
rho=max(mu1./abs(r1),mu2./abs(r2));
[m,argm]=min(rho);
if m<1
    if nu(argm)<1
        vcase=1;
    else vcase=2;end;

else
    if min(nu)<1
        vcase=3;
    else vcase=4;
    end;
end;
out=vcase;
end