%%---------------------------------------------
%-----------Barthlemy & Marx (2018)-----------
%----------------------------------------------
% Name of the graph in the paper: Figure 7
% Graph of determinacy vis--vis alpha1 and alpha2  in a simple univariate
% cases (Proposition 3)
% Needed files: study_case2
%%---------------------------------------------

alpha1=[0.001:1/100:2.5+0.001];
alpha2=[0.001:1/100:2.5+0.001];
[ALPHA1,ALPHA2]=meshgrid(alpha1,alpha2)
for i=1:size(alpha1,2)
    for j=1:size(alpha2,2)

CASE(i,j)=study_case2(ALPHA1(i,j),ALPHA2(i,j),0.2,1.2,0.5);
    end
end

figure;
contour(ALPHA1,ALPHA2,CASE,3,'k','LineWidth',3)

saveas(gcf,'graphunivariate')